import utils
from controllers.base import BaseController
from db.database import Database
from template_engine.jinja import env
from utils import id_gen


class PostsController(BaseController):
    def get_list(self):
        tmp = env.get_template('posts/list.html')
        body = tmp.render(posts=Database.all())

        self.response.add_header('Content-Type', 'text/html')
        self.response.set_body(body)

    def new(self):
        tmp = env.get_template('posts/create.html')
        body = tmp.render(id=next(utils.id_gen))

        self.response.add_header('Content-Type', 'text/html')
        self.response.set_body(body)

    def create(self):
        id_ = next(id_gen)
        Database.add(
            {
                'id': id_,
                'title': self.request.body['title']
            }
        )

        self.response.add_header('Content-Type', 'text/html')
        self.response.set_status(301)
        self.response.add_header('Location', '/posts')
        self.response.set_body('<a href="/posts"">Back to posts list</a>')
